

:START
   @echo off
   cls

:DETECTARGUMENTS
   SET SINGLESESSION=1
   SET BLANK=1
   IF /I *%1 == *MULTI SET SINGLESESSION=0
   IF /I *%2 == *MULTI SET SINGLESESSION=0
   IF /I *%1 == *BLANK SET BLANK=0
   IF /I *%2 == *BLANK SET BLANK=0

:SETSOURCEFOLDER
   REM This will get the folder the batch file was launched from since the current
   REM directory will change if launched from a network share
   SET SOURCEFOLDER=%~dp0
   ECHO Source Folder is %SOURCEFOLDER%

:TAKEOWNERSHIP
   echo Taking ownership of %SystemRoot%\System32\termsrv.dll
   takeown /a /f %SystemRoot%\System32\termsrv.dll
   echo Granting Administrators rights
   icacls %SystemRoot%\System32\termsrv.dll /Grant Administrators:F

:STOPTERMINALSERVICES
   echo Stopping Terminal Services
   net stop "Terminal Services"

:BACKUPTERMSRVDLL
   copy %SystemRoot%\System32\termsrv.dll %SystemRoot%\System32\*.*.bak

:COPYTERMSRVDLL
   echo Copying %SOURCEFOLDER%termsrv.dll to %SystemRoot%\System32\
   copy /y "%SOURCEFOLDER%termsrv.dll" %SystemRoot%\System32\

:IMPORTREGKEYS
   echo Importing Registry Keys
   regedit /s "%SOURCEFOLDER%termonpremium.reg"
   echo Enabling RDP
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Terminal Server" /v fDenyTSConnections /t REG_DWORD /d 0 /f

:SETSINGLESESSIONSETTING
   ECHO Setting fSingleSessionPerUser to %SINGLESESSION%
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Terminal Server" /v fSingleSessionPerUser /t REG_DWORD /d %SINGLESESSION% /f

:SETBLANKPASSWORDPOLICY
   ECHO Setting LimitBlankPasswordUser to %BLANK%
   REG ADD "HKLM\SYSTEM\CurrentControlSet\Control\Lsa" /v LimitBlankPasswordUse /t REG_DWORD /d %BLANK% /f
   
:CONFIGUREFIREWALL
   ECHO Configuring Remote Desktop in Windows Firewall
   netsh firewall set service remotedesktop enable

:STARTTERMINALSERVICES
   echo Starting Terminal Services
   net start "Terminal Services"

:PAUSE5SECONDS
   ECHO Pausing 5 seconds to give service time to start listening
   choice /n /c y /d y /t 5 > nul

:CHECKIFSERVICELISTENING
   echo Checking if Service is listening on port 3389
   SUBST
   netstat -a | find /i "3389"
   if ERRORLEVEL 1 goto SERVICENOTLISTENING

:SERVICEISLISTENING
   echo Service is listening
   goto CONTINUE

:SERVICENOTLISTENING
   echo Service is not listening

:CONTINUE
   echo Done
   Pause  


